.syntax unified
.cpu cortex-m33
.fpu softvfp
.thumb
.thumb_func

//#define TEST_PIN_L		GPIOA->BSRR = GPIO_BSRR_BR5
//#define TEST_PIN_H		GPIOA->BSRR = GPIO_BSRR_BS5


//#define ADC_CS_L		GPIOB->BSRR = GPIO_BSRR_BR13
//#define ADC_CS_H		GPIOB->BSRR = GPIO_BSRR_BS13

//#define SPI1_RDY_PIN		10
	SPI1_RDY_PIN	= 10

/* GPIO_TypeDef */
	GPIOA	= 0x42020000
	GPIOB	= 0x42020400
	GPIOC	= 0x42020800
	oMODER		= 0
	oOTYPER		= 4
	oOSPEEDR	= 8
	oPUPDR		= 12

	oIDR		= 16
	oODR		= 20
	oBSRR		= 24
	oLCKR		= 28
	oAFR		= 32
	oBRR		= 40
	oHSLVR		= 44
	oSECCFGR	= 48

#define PERIPH_BASE_NS           (0x40000000UL) /*!< Peripheral non-secure base address                 */
#define APB1PERIPH_BASE_NS       PERIPH_BASE_NS
#define SPI2_BASE_NS             (APB1PERIPH_BASE_NS + 0x3800UL)

/* SPI_TypeDef */
	SPI2			= 0x40003800
	oSPI_CR1		= 0
	oSPI_CR2		= 4
	oSPI_CFG1		= 8
	oSPI_CFG2		= 12
	oSPI_IER		= 16
	oSPI_SR			= 20
	oSPI_IFCR		= 24
	oSPI_TXDR		= 32
	oSPI_RXDR		= 48

/* EXTI_TypeDef */
	EXTI		= 0x44022000
	oRTSR1		= 0
	oFTSR1		= 4
	oSWIER1		= 8
	oRPR1		= 12
	oFPR1		= 16



.section	.bss
Ads127l01:	.space 116
  o_spi_data		= 0
  o_adc_data		= 4
  o_Fkt			= 8
  o_AdcOffset		= 12
  o_OverSampDiv		= 16
  o_OverSampSum		= 20
  o_OverSampCount	= 24
  o_OverSampDiv2	= 28
  o_OverSampSum2	= 32
  o_OverSampCount2	= 36

  o_TrigHV		= 40
  o_TrigLV		= 44
  o_TrigMod		= 48
  o_TrigStat		= 52

  oIRR_kA		= 56
  oIRR_kB		= 60
  oIRR_X		= 68
  oIRR_Y		= 72

  oAnl_IRR_X		= 80
  oAnl_IRR_Y		= 84
  oAnl_IRR_Y2		= 88

  oAnl_Sum		= 96
  oAnl_Count		= 100
  oAnl_Value		= 104
//  oAnl_Stat		= 108
  oAnl_TestVal		= 112

//	ADSF_BAND_WIDTH_AUTO	= 1
	bADSF_BAND_WIDTH_AUTO	= 0

	bTRIG_LH		= 0
	bTRIG_HL		= 1
	bTRIG_EXT		= 2

	bTRIG_ST_H		= 0


.section	.text.SPI2_IRQHandler
.global SPI2_IRQHandler
//.extern SPI2_IRQHandler

.align 4
SPI2_IRQHandler:
// din = SPI2->RXDR << 8;
	ldr	r3, =SPI2
	ldr	r2, =Ads127l01
	ldr	r0, [r3, #oSPI_RXDR]
	ldr	r1, [r2, #o_AdcOffset]
	lsls	r0, r0, #8
// ex_adc1.spi_data = din >> 8;
	asrs	r0, r0, #8
	subs	r0, r1
	ssat	r0, #24, r0
	str	r0, [r2, #o_spi_data]
// ADC_CS_H;
	ldr	r3, =GPIOB
	mov	r0, 0x2000
	str	r0, [r3, #oBSRR]
	bx	lr


.section	.text.EXTI10_IRQHandler
.global EXTI10_IRQHandler
.syntax unified
.thumb
.thumb_func

.align 4
EXTI10_IRQHandler:
.if 0
// TEST_PIN_H;
	ldr	r3, =GPIOA
	movs	r0, 0x0020
	str	r0, [r3, #oBSRR]
.endif
	ldr	r3, =EXTI
	push	{r4, r5, lr}

	ldr	r0, [r3, #oFPR1]
	mov	r1, #1 << SPI1_RDY_PIN
	lsls	r0, #31 - SPI1_RDY_PIN
	bpl	Lende

	str	r1, [r3, #oFPR1]	//  EXTI->FPR1 = 1<<SPI1_RDY_PIN;

	ldr	r2, =GPIOB
	ldr	r3, =SPI2
	ldr	r4, =Ads127l01
	mov	r0, 0x20000000
	mov	r1, 0x12000000
	str	r0, [r2, #oBSRR]	//  SPI2->TXDR = 0x12000000;
	str	r1, [r3, #oSPI_TXDR]	//  ADC_CS_L;

	ldr	r5, [r4, #o_spi_data]

	ldr	r3, [r4, #oAnl_IRR_X]
	str	r5, [r4, #oAnl_IRR_X]
	mov	r2, #0x00060000
	adds	r3, r5
	smull	r0, r1, r2, r3

	ldr	r5, =0x7FF40000
	ldr	r2, [r4, #oAnl_IRR_Y2]
	ldr	r3, [r4, #oAnl_IRR_Y]

	smlal	r0, r1, r2, r5
	umull	r2, r3, r3, r5
	adds	r0, r3
	adc	r1, #0

// res <<= 1;
	adds	r0, r0
	adcs	r1, r1
	str	r0, [r4, #oAnl_IRR_Y]
	str	r1, [r4, #oAnl_IRR_Y2]
	adds	r0, r0

	ldr	r0, [r4, #oAnl_Sum]
	ldr	r2, [r4, #oAnl_Count]
	adcs	r0, r1
	str	r0, [r4, #oAnl_Sum]
	adds	r2, #1
	cmp	r2, #100
	blt	AnlNext
	movs	r2, #0
	str	r0, [r4, #oAnl_Value]
	str	r2, [r4, #oAnl_Sum]
AnlNext:
	str	r2, [r4, #oAnl_Count]

/* ------------------------- Oszi IRR ----------------------------------- */
	ldr	r2, [r4, #oIRR_kA]
	ldr	r5, [r4, #o_spi_data]
//	ldr	r5, [r4, #oAnl_TestVal]
	cbz	r2, IRR_end

	ldr	r3, [r4, #oIRR_X]
	str	r5, [r4, #oIRR_X]
//	smull	r0, r1, r2, r5
//	smlal	r0, r1, r2, r3
	adds	r3, r5
	smull	r0, r1, r2, r3

// temp_i64 = (IRR_Y * kB) >> 32;
	ldr	r5, [r4, #oIRR_kB]
	ldr	r2, [r4, #oIRR_Y+4]
	ldr	r3, [r4, #oIRR_Y]

	smlal	r0, r1, r2, r5
	umull	r2, r3, r3, r5
	adds	r0, r3
	adc	r1, #0

// res <<= 1;
	adds	r0, r0
	adcs	r1, r1
	str	r0, [r4, #oIRR_Y]
	str	r1, [r4, #oIRR_Y+4]
	mov	r5, r1
IRR_end:
/* ------------------------- Oszi OSR ----------------------------------- */

	ldr	r0, [r4, #o_Fkt]
	ldr	r3, [r4, #o_OverSampDiv]
	lsls	r0, #31 - bADSF_BAND_WIDTH_AUTO
	bpl	L_OSampNoAutoBw
	cbz	r3, Ladc_dir

	ldr	r0, [r4, #o_OverSampSum]
	ldr	r1, [r4, #o_OverSampCount]
	adds	r5, r0
	str	r5, [r4, #o_OverSampSum]

	adds	r1, #1
	str	r1, [r4, #o_OverSampCount]
	cmp	r3, r1
	bgt	Lende

	movs	r0, #0
	sdiv	r5, r5, r3
	str	r0, [r4, #o_OverSampSum]
	str	r0, [r4, #o_OverSampCount]

/* sum 2 */
	ldr	r3, [r4, #o_OverSampDiv2]
	cbz	r3, Ladc_dir

	ldr	r0, [r4, #o_OverSampSum2]
	ldr	r1, [r4, #o_OverSampCount2]
	adds	r5, r0
	str	r5, [r4, #o_OverSampSum2]

	adds	r1, #1
	str	r1, [r4, #o_OverSampCount2]
	cmp	r3, r1
	bgt	Lende

	movs	r0, #0
	sdiv	r5, r5, r3
	str	r0, [r4, #o_OverSampSum2]
	str	r0, [r4, #o_OverSampCount2]


Ladc_dir:
//	ldr	r0, [r4, #o_AdcOffset]
//	subs	r5, r0
//	ssat	r5, #24, r5
	str	r5, [r4, #o_adc_data]
.if 1
/* ------------------ Trigger ------------------------------------------- */
	ldrh	r1, [r4, #o_TrigMod]
	lsls	r2, r1, #31 - bTRIG_EXT
	bmi	L_TrigExt

	ldr	r0, [r4, #o_TrigHV]
	ldr	r1, [r4, #o_TrigLV]

	cmp	r5, r0
	ble	L_TrigHL
	ldrh	r0, [r4, #o_TrigStat]
	ldrh	r1, [r4, #o_TrigMod]
L_ExtTrigLH:
	lsls	r2, r0, #31 - bTRIG_ST_H
	bmi	L_TrigEnd
	orr	r0, #1<<bTRIG_ST_H
	strh	r0, [r4, #o_TrigStat]

	lsls	r2, r1, #31 - bTRIG_LH
	bpl	L_TrigEnd
	bal	L_TrigEv

L_TrigHL:
	cmp	r5, r1
	bge	L_TrigEnd
	ldrh	r0, [r4, #o_TrigStat]
	ldrh	r1, [r4, #o_TrigMod]
L_ExtTrigHL:
	lsls	r2, r0, #31 - bTRIG_ST_H
	bpl	L_TrigEnd
	bic	r0, #1<<bTRIG_ST_H
	strh	r0, [r4, #o_TrigStat]

	lsls	r2, r1, #31 - bTRIG_HL
	bpl	L_TrigEnd
L_TrigEv:
	ldr	r0, =rb3b
	bl	RingBuf3B_SetTrig
L_TrigEnd:
.endif

//	ldr	r1, =Ads127l01 + o_adc_data
	adds	r1, r4, #o_adc_data
	ldr	r0, =rb3b
	bl	RingBuf3B_Add
Lende:
.if 0
// TEST_PIN_L;
	ldr	r3, =GPIOA
	mov	r0, 0x00200000
	str	r0, [r3, #oBSRR]
.endif
	pop	{r4, r5, pc}

L_TrigExt:
	ldr	r3, =GPIOA
	ldrh	r0, [r4, #o_TrigStat]
	ldr	r3, [r3, #16]
	lsls	r3, r3, #31 - 3
	bpl	L_ExtTrigHL
	bal	L_ExtTrigLH

L_OSampNoAutoBw:
	ldr	r1, [r4, #o_OverSampDiv]
	ldr	r2, [r4, #o_OverSampDiv2]
	cmp	r1, #1
	ble	Ladc_dir
	ldr	r0, [r4, #o_OverSampCount]
	adds	r0, #1
	str	r0, [r4, #o_OverSampCount]
	cmp	r1, r0
	bgt	Lende
	movs	r3, #0
	str	r3, [r4, #o_OverSampCount]

	cmp	r2, #1
	ble	Ladc_dir
	ldr	r0, [r4, #o_OverSampCount2]
	adds	r0, #1
	str	r0, [r4, #o_OverSampCount2]
	cmp	r2, r0
	bgt	Lende
	str	r3, [r4, #o_OverSampCount2]

	bal	Ladc_dir

//	bx	lr

.section	.text.Ads127l01_SetOverSampDiv
.global Ads127l01_SetOverSampDiv
.syntax unified
.thumb
.thumb_func
.align 2

//Ads127l01_SetOverSampDiv(int32_t OverSampDiv1, int32_t OverSampDiv2)
Ads127l01_SetOverSampDiv:
	ldr	r3, =Ads127l01
	movs	r2, #0
	str	r2, [r3, #o_OverSampCount]
	str	r2, [r3, #o_OverSampSum]
	str	r2, [r3, #o_OverSampCount2]
	str	r2, [r3, #o_OverSampSum2]

	cmp	r0, #1
	it	eq
	moveq	r0, #0
	str	r0, [r3, #o_OverSampDiv]

	cmp	r1, #1
	it	eq
	moveq	r1, #0
	str	r1, [r3, #o_OverSampDiv2]
	bx	lr

.section	.text.Ads127l01_SetBandWidth
.global Ads127l01_SetBandWidth
.syntax unified
.thumb
.thumb_func
.align 2

//void Ads127l01_SetBandWidth(bool bw_auto)
Ads127l01_SetBandWidth:
	ldr	r3, =Ads127l01
	ldr	r1, [r3, #o_Fkt]
	bic	r1, #1<<bADSF_BAND_WIDTH_AUTO
	cbz	r0, sbwe
	orr	r1, #1<<bADSF_BAND_WIDTH_AUTO
sbwe:
	str	r1, [r3, #o_Fkt]
	bx	lr


.section	.text.Ads127l01_SetTrigger
.global Ads127l01_SetTrigger
.syntax unified
.thumb
.thumb_func
.align 2

//void Ads127l01_SetTrigger(int32_t TrigHV, int32_t TrigLV, uint16_t TrigMod)
Ads127l01_SetTrigger:
	ldr	r3, =Ads127l01
	str	r0, [r3, #o_TrigHV]
	str	r1, [r3, #o_TrigLV]
	strh	r2, [r3, #o_TrigMod]
	movs	r0, #0
	strh	r0, [r3, #o_TrigStat]
	bx	lr


.section	.text.Ads127l01_SetIRR
.global Ads127l01_SetIRR
.syntax unified
.thumb
.thumb_func
.align 2

//void Ads127l01_SetIRR(uint32_t IRR_InMul, uint32_t fkt);
Ads127l01_SetIRR:
	ldr	r3, =Ads127l01
	str	r0, [r3, #oIRR_kA]
	cbz	r0, lret
	lsls	r0, #1
	rsb	r0, r0, #0x80000000
	str	r0, [r3, #oIRR_kB]
lret:
	bx	lr

/* ----------------------- Ads127l01_SetOffset -------------------------- */
.section	.text.Ads127l01_SetOffset
.global Ads127l01_SetOffset
.syntax unified
.thumb
.thumb_func
.align 2
//void Ads127l01_SetOffset(int32_t Offs);
Ads127l01_SetOffset:
	ldr	r3, =Ads127l01
	str	r0, [r3, #o_AdcOffset]
	bx	lr

/* ----------------------- Ads127l01_GetAnlVal -------------------------- */
.section	.text.Ads127l01_GetAnlVal
.global Ads127l01_GetAnlVal
.syntax unified
.thumb
.thumb_func
.align 2
//bool Ads127l01_GetAnlVal(int32_t *AnlVal)
.if 1
Ads127l01_GetAnlVal:
	ldr	r3, =Ads127l01
	ldr	r2, [r3, #oAnl_Value]
	mov	r1, #0x80000000
	cmp	r1, r2
	beq	lret_false
	str	r1, [r3, #oAnl_Value]
	mov	r1, #100
	sdiv	r2, r2, r1

	str	r2, [r0, #0]
	movs	r0, #1
	bx	lr
lret_false:
	movs	r0, #0
	bx	lr

.else
Ads127l01_GetAnlVal:
	ldr	r3, =Ads127l01
	ldr	r1, [r3, #oAnl_Stat]
	cbnz	r1, lret_false
	ldr	r1, [r3, #oAnl_Value]
	str	r1, [r0, #0]
	movs	r0, #1
	str	r0, [r3, #oAnl_Stat]
	bx	lr
lret_false:
	movs	r0, #0
	bx	lr
.endif
/* ----------------------- Ads127l01_SetTestVal ------------------------- */
.section	.text.Ads127l01_SetTestVal
.global Ads127l01_SetTestVal
.syntax unified
.thumb
.thumb_func
.align 2
//void Ads127l01_SetTestVal(int32_t AnlVal)
Ads127l01_SetTestVal:
	ldr	r3, =Ads127l01
	str	r0, [r3, #oAnl_TestVal]
	bx	lr
