#ifndef ADS127L01_H
#define ADS127L01_H

#define ADS127L01_DIGV		(2.5 / 8388608.0)
#define ADS127L01_1p_DIGV	(8388608.0 / 2.5)

#define ADC_BASE_KORR	(1.0266 / 16777216.0)

typedef union {
  int64_t  i64;
  int64_t  u64;
  int32_t  i32[2];
  int32_t  u32[2];
} Tx64;

#define TRIG_LH			1
#define TRIG_HL			(1<<1)
#define TRIG_EXT		(1<<2)

#define TRIG_ST_H		1


#define ADSF_BAND_WIDTH_AUTO	1

typedef struct {
  uint32_t spi_data;
  uint32_t Fkt;

  int32_t OverSampDiv;
  int32_t OverSampSum;
  uint32_t OverSampCount;

  int32_t OverSampDiv2;
  int32_t OverSampSum2;
  uint32_t OverSampCount2;

  int32_t TrigHV;
  int32_t TrigLV;
  uint16_t TrigMod;
  uint16_t TrigStat;

  int32_t IRR_InMul;
  int32_t IRR_yMUL;

  int64_t IRR_X;
  Tx64 IRR_Y;

  int32_t FValue;
  int32_t F256count;
  int32_t F256sum;
  int32_t F40sum;
  int32_t F40count;
  int32_t Anl_IRR_X;
  int32_t Anl_IRR_Y;
  int32_t Anl_IRR_X2;
  int32_t Anl_IRR_Y2;
  uint32_t Anl_Stat;
  int32_t Anl_TestVal;


} TAds127l01;

//extern TAds127l01 ex_adc1;

void Ads127l01_Init();
void Ads127l01_Start();
void Ads127l01_Stop();
void Ads127l01_SetOverSampDiv(int32_t OverSampDiv1, int32_t OverSampDiv2);
void Ads127l01_SetBandWidth(bool bw_auto);
void Ads127l01_SetTrigger(int32_t TrigHV, int32_t TrigLV, uint16_t TrigMod);
void Ads127l01_SetIRR(uint32_t IRR_InMul, uint32_t fkt);
void Ads127l01_SetOffset(int32_t Offs);
bool Ads127l01_GetAnlVal(int32_t *AnlVal);
void Ads127l01_SetTestVal(int32_t AnlVal);

#endif  /* ADS127L01_H */
