
#ifndef RINGBUF3B_H
#define RINGBUF3B_H

//#define RB3ST_WR_STOP		1
//#define RB3ST_LOCK_B1		(1<<1)
//#define RB3ST_LOCK_B2		(1<<2)
#define RB3ST_RD_AKTIV		1
#define RB3ST_USE_TRIGER	(1<<1)
#define RB3ST_FREE_RUN		(1<<2)
#define RB3ST_SINGLE		(1<<3)

#define RB3RST_WR_WAIT		1
#define RB3RST_B2_AKTIV		(1<<1)
#define RB3RST_HAS_DATA		(1<<2)
#define RB3RST_HAS_TRIG		(1<<3)
#define RB3RST_NEW_DATA		(1<<4)

typedef struct {
  uint16_t stat;
  uint16_t rstat;
  uint16_t bstat;
  uint16_t nc_u16;
  int32_t items;
//  uint32_t samps;
  int32_t in_count;
  int32_t trig_pos;

  uint8_t *data;
  uint8_t *data_anf;
  uint8_t *data_end;

  uint8_t *data1;
  uint8_t *data1_anf;
  uint8_t *data1_end;
  uint8_t *data2;
  uint8_t *data2_anf;
  uint8_t *data2_end;
  int32_t Akt_Offset;	/* Data  + Offset = Value */
  int32_t Offset;	/* Data  + Offset = Value */
  int32_t Offset2;	/* Data2 + Offset = Value */
  uint32_t FrameNum;

  uint8_t *src;
  uint8_t *src_anf;
  uint8_t *src_end;
  uint32_t read_size;
  int32_t  Data_Offset;	/* Data  + Offset = Value */

} RingBuffer3B;

//void RingBuf3B_ClrData(RingBuffer3B *p3);
void RingBuf3B_Init(RingBuffer3B *p3, uint32_t count); /* +RingBuf3B_ClrData */
uint32_t *RingBuf3B_ClrData_seg(uint32_t *p);	/* max time 100us */
void RingBuf3B_Pos0(RingBuffer3B *p3);

void RingBuf3B_TrigOnOff(RingBuffer3B *p3, uint16_t value);


uint32_t RingBuf3B_GetCount(RingBuffer3B *p3);

void RingBuf3B_Add(RingBuffer3B *p3, uint8_t *val);
void RingBuf3B_SetTrig(RingBuffer3B *p3);
int32_t RingBuf3B_GetOffset(RingBuffer3B *p3);
void RingBuf3B_GetDataInit(RingBuffer3B *p3);
int RingBuf3B_GetData(RingBuffer3B *p3, uint8_t *dest, int size);

#endif	/* RINGBUF3B_H */
