
#ifndef SCPI_H
#define SCPI_H

#define SCPI_OK		1
#define SCPI_TXD	(1<<1)
#define SCPI_TXD_BUF	(1<<2)

#define RINGBUF3_MAX_COUNT	35000
#define RINGBUF3S_MAX_COUNT	(RINGBUF3_MAX_COUNT * 2)

#define ERR_SYNTAX			102
#define ERR_MISSING_PARAMETER		109
#define ERR_UNDEFINED_HEADER		113
#define ERR_ILLEGAL_PARAMETER_VALUE	224
#define ERR_OVERVOLTAGE			310


typedef struct {
  int stat;
  uint8_t  *tx_data;
  uint32_t tx_data_len;
  uint16_t err[4];	// err[0] = count 0..3   err[1..3] = ErrNo
//  RingBuffer3B p3;
} TScpi;

extern TScpi Scpi;

void scpi_line_set(uint8_t *line, uint32_t len, TScpi *Scpi);
void scpi_set_str(const char *s);
void scpi_set_str_U32(uint32_t val);
void scpi_set_str_float(float val, int decipoint);

void AddError(uint16_t err_no);


#endif	/* SCPI_H */
