
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __USBD_CDC_IF_H
#define __USBD_CDC_IF_H

/* Includes ------------------------------------------------------------------*/
#include "usb_tmc.h"

/* Periodically, the state of the buffer "UserTxBuffer" is checked.
   The period depends on CDC_POLLING_INTERVAL */
#define CDC_POLLING_INTERVAL             5 /* in ms. The max is 65 and the min is 1 */

//extern USBD_CDC_ItfTypeDef  USBD_CDC_fops;


#define CDC_RXD_DATA	1

#define TMC_RX_DATA_SIZE  512
#define APP_TX_DATA_SIZE  2048

extern uint8_t TmcRxBuffer[TMC_RX_DATA_SIZE];/* Received Data over USB are stored in this buffer */
extern uint8_t TmcTxBuffer[APP_TX_DATA_SIZE];/* Received Data over UART (CDC interface) are stored in this buffer */

extern uint32_t usbd_cdc_status;
extern uint32_t usbd_cdc_RxLen;
extern uint32_t usbd_cdc_RxTimeOut_ms;

void USB_TMC_DefaultInit();


int8_t CDC_Transmit(uint8_t *Buf, uint32_t len);

void TMC_TransmitNext(PCD_HandleTypeDef *hpcd, PCD_EPTypeDef *ep);

#endif /* __USBD_CDC_IF_H */
