#include "main.h"

void SystemInit () {


	RCC->AHB1ENR = 0xD0000100;

	RCC->AHB2ENR = 0xC0000000 | RCC_AHB2ENR_GPIOAEN |
			RCC_AHB2ENR_GPIOBEN | RCC_AHB2ENR_GPIOCEN;


	/* GPIOA Reset = 0xABFFFFFF */
	/* A2=5VEN A5=Test A6=TRGOEN */

	GPIOA->MODER =  GPIO_MODER_MODE0    | GPIO_MODER_MODE1    |
			GPIO_MODER_MODE2_0  | GPIO_MODER_MODE3    |
			GPIO_MODER_MODE4    | GPIO_MODER_MODE5_0  |
			GPIO_MODER_MODE6_0  | GPIO_MODER_MODE7    |
			GPIO_MODER_MODE8    | GPIO_MODER_MODE9    |
			GPIO_MODER_MODE10   | GPIO_MODER_MODE11   |
			GPIO_MODER_MODE12   | 0xA8000000 ;

	/* GPIOB Reset = 0xFFFFFEBF */
	/* B0=OPVEN B1=LED_RT B2=LED_GN 4=CPEN 5=K1
	    8=K2 10=Filt1 12=ARES 13=ACS */
	GPIOB->MODER =  GPIO_MODER_MODE0_0  | GPIO_MODER_MODE1_0  |
			GPIO_MODER_MODE2_0  | GPIO_MODER_MODE3    |
			GPIO_MODER_MODE4_0  | GPIO_MODER_MODE5_0  |
			GPIO_MODER_MODE6    | GPIO_MODER_MODE7    |
			GPIO_MODER_MODE8_0  | GPIO_MODER_MODE9    |
			GPIO_MODER_MODE10_0 | GPIO_MODER_MODE11   |
			GPIO_MODER_MODE12_0 | GPIO_MODER_MODE13_0 |
			GPIO_MODER_MODE14   | GPIO_MODER_MODE15 ;

	ADC_CS_H;

	/* GPIOC Reset = 0xFFFFFFFF */
	/* 13=K3 14=K4 15=AC/DC */
//	GPIOC->MODER = 0xD7FFFFFF;
	GPIOC->MODER =  GPIO_MODER_MODE0    | GPIO_MODER_MODE1    |
			GPIO_MODER_MODE2    | GPIO_MODER_MODE3    |
			GPIO_MODER_MODE4    | GPIO_MODER_MODE5    |
			GPIO_MODER_MODE6    | GPIO_MODER_MODE7    |
			GPIO_MODER_MODE8    | GPIO_MODER_MODE9    |
			GPIO_MODER_MODE10   | GPIO_MODER_MODE11   |
			GPIO_MODER_MODE12   | GPIO_MODER_MODE13_0 |
			GPIO_MODER_MODE14_0 | GPIO_MODER_MODE15_0 ;

    LED_RED_ON;
    LED_GREEN_OFF;

#if 1
/*   RM0481  S_251  Table_44
	VOS3 MHz	VOS2 MHz	VOS1 MHz	VOS0 MHz
4 WS	80..100		120..150	136..170	168..210
5 WS	 ---		  --		170..200	210..250
*/
	FLASH->ACR = FLASH_ACR_LATENCY_5WS | FLASH_ACR_WRHIGHFREQ_1;

    /* Configure the main internal regulator output voltage */
	PWR->VOSCR = PWR_VOSCR_VOS;
	while ((PWR->VOSSR & PWR_VOSSR_VOSRDY) == 0);

    /* Enable HSE */
	RCC->CR = 0x0000002B | RCC_CR_HSEON;
    /* Wait till HSE is ready */

	while ((RCC->CR & RCC_CR_HSERDY) == 0);

// RCC->PLL1FRACR = 0xFE00;

#define RCC_PLL1_CONFIG(_PLL1FKT_, _PLL1M_, _PLL1N_, _PLL1P_, _PLL1Q_, _PLL1R_) \
    RCC->PLL1CFGR |= _PLL1FKT_ | (_PLL1M_ << RCC_PLL1CFGR_PLL1M_Pos); \
    RCC->PLL1DIVR = ( ((_PLL1N_  - 1) & RCC_PLL1DIVR_PLL1N) | \
		      (((_PLL1P_ - 1) << RCC_PLL1DIVR_PLL1P_Pos) & RCC_PLL1DIVR_PLL1P) | \
		      (((_PLL1Q_ - 1) << RCC_PLL1DIVR_PLL1Q_Pos) & RCC_PLL1DIVR_PLL1Q) | \
		      (((_PLL1R_ - 1) << RCC_PLL1DIVR_PLL1R_Pos) & RCC_PLL1DIVR_PLL1R));

	RCC_PLL1_CONFIG(RCC_PLL1CFGR_PLL1SRC_0 | RCC_PLL1CFGR_PLL1SRC_1 |
			    RCC_PLL1CFGR_PLL1RGE_0 | 
			    RCC_PLL1CFGR_PLL1PEN | RCC_PLL1CFGR_PLL1QEN, 
			    4, 240, 2, 5, 2);

// RCC->PLL1CFGR |= RCC_PLL1CFGR_PLL1FRACEN;


	RCC->CR |= RCC_CR_PLL1ON;
	while ((RCC->CR & RCC_CR_PLL1RDY) == 0);

	RCC->CFGR1 = (RCC_CFGR1_SW_0 | RCC_CFGR1_SW_1);
	while ((RCC->CFGR1 & RCC_CFGR1_SWS) != (RCC_CFGR1_SWS_0 | RCC_CFGR1_SWS_1));

    /* Initializes the CPU, AHB and APB buses clocks */
	RCC->CFGR2 = 0;

	ICACHE->CR |= ICACHE_CR_EN;
//	DCACHE1->CR |= DCACHE_CR_EN;
#endif
/*
  Set Interrupt Group Priority 
  3 = 4 bits for pre-emption priority,  0 bit  for subpriority
*/
	NVIC_SetPriorityGrouping(3);

	SysTick->CTRL = 0U;
	SysTick->VAL = 0U;
	SysTick->LOAD = (SYS_CLK / 1000 / SYS_CLK_COUNT_P_MS) - 1;
	SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk |
			SysTick_CTRL_TICKINT_Msk |
			SysTick_CTRL_ENABLE_Msk;	/* Enable SysTick IRQ and SysTick Timer */


  /* --- FPU settings --------------------------------------------------- */

	SCB->CPACR |= ((3UL << 20U)|(3UL << 22U));  /* set CP10 and CP11 Full Access */

	RCC->APB3ENR |= RCC_APB3ENR_SBSEN;
  uint32_t fpscr;
 /* clr any FPU error */
	fpscr = __get_FPSCR();
	fpscr &= (uint32_t)~0x8F;
	__set_FPSCR(fpscr);

	NVIC_EnableIRQ(FPU_IRQn);
	NVIC_SetPriority(FPU_IRQn, 0);

}
