#include "main.h"

__IO uint32_t TimerCount;
__IO uint32_t TimerCount_ms;
static uint32_t tms;

__attribute__((aligned(16))) 
uint32_t HAL_GetTick() {
	return TimerCount;
}

__attribute__((aligned(16))) 
void SysTick_Handler(void) {
	TimerCount++;
	tms++;
	if (tms == SYS_CLK_COUNT_P_MS) {
	    TimerCount_ms++;
	    tms = 0;
	}
}

void HAL_Delay(uint32_t wait_ms) {
  uint32_t tickstart, wait;

	wait = wait_ms;
	if (wait > 10000) wait = 10000;
	wait *= SYS_CLK_COUNT_P_MS;	
	tickstart = TimerCount;
	while ((TimerCount - tickstart) < wait);
}
