
#include "main.h"
#include <stdio.h>
#include "libh523.h"

/* 0.0195 / ((100 / 10000) + 1) = 0.0193 */
#define TMP236_V_PER_C		(1.0 / 0.0193 / 1.01)
#define TMP236_V_OFF		(0.400 / 1.01)
#define V_PER_BIT		(3.3 / 16384.0)

static float TempOffset;

float TMP236GetTemp(int AnlVal) {
  float result;

	result = (float)AnlVal * V_PER_BIT;
	result -= TMP236_V_OFF;
	result *= TMP236_V_PER_C;
	result += TempOffset;
	return result;
}

void TMP236SetTempOffset(float Value) {
	if (Value > 30.0) Value = 30.0;
	if (Value < -30.0) Value = -30.0;
	TempOffset = Value;
}
/*
float TMP236GetTempOffset() {
	return TempOffset;
}
*/
