
#include "main.h"
#include "libh523.h"

void CONSOLE_Init() {

  /* USART1 GPIO Configuration
  PB6   ------> USART1_TX	AF_7
  PB7   ------> USART1_RX	AF_7
  */

	RCC->APB2ENR |= RCC_APB2ENR_USART1EN;

	MODIFY_REG(GPIOB->MODER, 
			GPIO_MODER_MODE6   | GPIO_MODER_MODE7,
			GPIO_MODER_MODE6_1 | GPIO_MODER_MODE7_1);

	MODIFY_REG(GPIOB->AFR[0], 
			GPIO_AFRL_AFSEL6 | GPIO_AFRL_AFSEL7,
			(7 << GPIO_AFRL_AFSEL6_Pos) | (7 << GPIO_AFRL_AFSEL7_Pos));

	USART1->BRR = (SYS_CLK + (CONSOLE_BAUD_RATE / 2)) / CONSOLE_BAUD_RATE;
//	USART1->PRESC = 0;
	USART1->CR1 = USART_CR1_FIFOEN | USART_CR1_UE | USART_CR1_TE | USART_CR1_RE;
}

void CONSOLE_WriteByte( int data ) {
	while ((USART1->ISR & USART_ISR_TXE) == 0U);
	USART1->TDR = data;
}

bool CONSOLE_Write( void *buffer, const size_t size ) {

    size_t idx;
    uint8_t *data;

	if (buffer && size > 0) {
	    idx = 0;
	    data = buffer;
            while( size > idx ) {
		while ((USART1->ISR & USART_ISR_TXE) == 0U);
		USART1->TDR = data[idx];
		idx++;
	    }
	}
	return true;
}
