
#ifndef LIB_H523_H
#define LIB_H523_H

typedef union {
  uint16_t u;
  int16_t  i;
  uint8_t u8[2];
  int8_t  i8[2];
  char  c[2];
} Txc16;

void CONSOLE_Init();
void CONSOLE_WriteByte( int data );
bool CONSOLE_Write( void *buffer, const size_t size );

#define CONSOLE_ReceiverIsReady() (USART1->ISR & USART_ISR_RXNE)
#define CONSOLE_ReadByte() (USART1->RDR & 0xff)


void FlashClrError();
uint8_t FlashWait(uint32_t Timeout);
uint8_t FlashUnlock();
uint8_t FlashLock();
void FlashProgramQuadWord(uint32_t **FlashAddress, uint32_t **DataAddress);
uint8_t FlashErase(uint32_t Sector);


/* ADC   PA0 PA1 PA7 Analog Input */
extern Txc16 anl0_val;
extern Txc16 anl1_val;
extern Txc16 anl2_val;

void ADC_Init();
int ADC1_ReadAndNextSamp();

/* ------------------- TMP236.c ---------------------------------------- */
/* TMP236GetTemp  Result 0.1C */
float TMP236GetTemp(int AnlVal);
void TMP236SetTempOffset(float Value);
//float TMP236GetTempOffset();

void DAC_Init();

/* ------------------ irr16b_32_k3FFF.s --------------------------------- */
typedef struct {
  int32_t x[4];
} TIRR16b_32;

void irr16b_32_k3FFF_init(TIRR16b_32 *p, int32_t k); /* k1 ... k16383 */
int32_t irr16b_32_k3FFF(TIRR16b_32 *p, int32_t value);

int32_t RelaisTvKorr();
void RelaisTvKorrInit();

#endif

