
#include "main.h"
#include "utils.h"
#include "oszi.h"
#include "libh523.h"


typedef struct {
  TIRR16b_32 K2aIrr;
  TIRR16b_32 K3aIrr;
  TIRR16b_32 K4aIrr;

  TIRR16b_32 K2Irr;
  TIRR16b_32 K3Irr;
  TIRR16b_32 K4Irr;
  int32_t vK2, vK3, vK4;
} TRelaisTvKorr;

static TRelaisTvKorr rk;

int32_t RelaisTvKorr() {
  int32_t i32, i32_2, res;
  TRelaisTvKorr *prk;
  TFlashData *fd;

	prk = &rk;
	fd = (void*)FlashBuffer;

	i32 = 0;
	i32_2 = fd->K2_TV;
	if (ADC_K2_STAT) i32 = i32_2;
	i32 = irr16b_32_k3FFF(&prk->K2aIrr, i32);
	prk->vK2 = i32_2 - irr16b_32_k3FFF(&prk->K2Irr, i32);

	i32 = 0;
	i32_2 = fd->K3_TV;
	if (ADC_K3_STAT) i32 = i32_2;
	i32 = irr16b_32_k3FFF(&prk->K3aIrr, i32);
	prk->vK3 = i32_2 - irr16b_32_k3FFF(&prk->K3Irr, i32);

	i32 = 0;
	i32_2 = fd->K4_TV;
	if (ADC_K4_STAT) i32 = i32_2;
	i32 = irr16b_32_k3FFF(&prk->K4aIrr, i32);
	prk->vK4 = i32_2 - irr16b_32_k3FFF(&prk->K4Irr, i32);

	res = 0;
	if (ADC_K2_STAT && ADC_K3_STAT && ADC_K4_STAT) {
	    res = (prk->vK2 + prk->vK3 + prk->vK4) / 2;
	} else if (ADC_K2_STAT) {
	    res = prk->vK2;
	} else if (ADC_K3_STAT) {
	    res = prk->vK3;
	} else if (ADC_K4_STAT) {
	    res = prk->vK4;
	}

	return res;
}

void RelaisTvKorrInit() {
  TRelaisTvKorr *prk;

	prk = &rk;
/* IRR Time ~ 20sec */
	irr16b_32_k3FFF_init(&prk->K2aIrr, 40);
	irr16b_32_k3FFF_init(&prk->K3aIrr, 40);
	irr16b_32_k3FFF_init(&prk->K4aIrr, 40);

/* IRR Time ~ 200sec */
	irr16b_32_k3FFF_init(&prk->K2Irr, 5);
	irr16b_32_k3FFF_init(&prk->K3Irr, 5);
	irr16b_32_k3FFF_init(&prk->K4Irr, 5);
}
